ADN Open CIS
Сообщество программистов Autodesk в СНГ

30/05/2013

Свойства примитивов в JIG не появляются в OPM (Панель свойств)

Вопрос:

Мой код очень точно следует примеру "ObjectARX 2009 SDK\samples\editor\Palettes\BoltSolution", но свойства примитивов во время JIG не появляются в Панели свойств (OPM).

Ответ:

После просмотра кода стало ясно, что вы забыли добавить флаг ACRX_CMD_INTERRUPTIBLE к флагам команды, которая стартует JIG:

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Рисование горизонтального текста в собственном примитиве

Вопрос:

Как рисовать текст в собственном примитиве, который будет всегда горизонтальным вне зависимости от направления вида и поворота при печати?

Ответ:

Вы можете использовать метод AcGiViewport::getCameraUpVector() чтобы получить вектор, направленный вверх для текущего вида. Имея этот вектор вы легко можете получить направление для отрисовки горизонтального текста в этом виде.

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Рекомендуемый способ для получения доступа к AutoCAD COM интерфейсу с помощью C++

Общий способ доступа к объекту интерфейсу AutoCAD – вызов функции GetActiveObject, но он может вернуть NULL в ряде случаев (и в частности в событии On_kInitAppMsg), а также не гарантируется доступ к текущему AutoCAD...

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Расчленение текстовых примитивов

Вопрос:

Как расчленить основанные на SHX-шрифтах примитивы AcDbText на входящие в их состав линии?

Ответ:

Вы можете “расчленить” или тессиллировать текстовый примитив, используя метод AcGiTextEngine::tessellate(). Но этот метод возвращает необработанную информацию о точках, которая может быть использована для создания отдельных линий. Метод этот не учитывает свойства текстового стиля и высоту текста, а ширина подразумевается единичной.

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Программное сохранение активного документа в C++/ARX приложении

Используем ActiveX интерфейс внутри ARX-приложения. Следующий пример кода показывает два подхода. Обратите внимание, что проект ARX-приложения должен поддерживать клиентские интерфейсы AutoCAD ActiveX. При помощи помощника (wizard) ARX это сделать очень просто.

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Проверка состояния готовности AutoCAD с использованием OLE

Вопрос:
Как можно проверить статус готовности AutoCAD средствами OLE автоматизации? Как можно предотвратить диалог "Ошибка. Сервер занят" ("Server Busy Error")?

Ответ:
Для надежной проверки того доступен ли AutoCAD для вызова или нет вы можете использовать проверку IAcadState. Вам нужно создать глобальный инициализированный объект IAcadState в момент когда AutoCAD не занят. Для любых последующих запросов автоматизации вы можете проверять состояние занятости AutoCAD используя объект IAcadState, а затем или дождаться когда AutoCAD освободится или отменить запрос.

Опубликовано 30.05.2013     Читать далее >>>
30/05/2013

Преобразование AcGePoint3d в ads_point и наоборот

Функция asDblArray() позволяет преобразовать при необходимости AcGePoint3d в ads_point.

Опубликовано 30.05.2013     Читать далее >>>
29/05/2013

Получение информации о гранях из AcDbPolyFaceMesh и AcDbPolygonMesh

Вопрос:

Я бы хотел получить информацию о гранях для примитивов полигональных и многогранных сетей. Есть ли пример как это можно сделать?

Ответ:

Следующие примеры кода рисуют отрезки поперёк всех граней выбранных примитивов полигональной и многогранной сетей.

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Получение граней SubD Сети

Если вы хотите получить все грани геометрии поверхности AcDbSubDMesh (называемой просто "Сеть" в Палитре свойств), то вы можете использовать либо getFaceArray (возвращает базовый (уровня 0) список граней сети) или getSubDividedFaceArray (возврат список граней сглаженной сети).

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Получение имени блока в ARX

Вопрос:
Могу ли я используя ObjectARX получить имя блока из вставки блока внутри ObjectARX приложения? Я знаю, что это можно сделать используя ads_entget (acdbEntGet), а затем найти соответствующий код группы.

Ответ:
Нет метода у класса вставки блока, который бы возвращал имя определения блока. Вставка блока (класс AcDbBlockReference) хранит ID объекта определения блока (класс AcDbBlockTableRecord). Имя блока хранится в определении блока. Чтобы получить имя блока нужно получить ID определения блока и открыть его. Тогда можно будет получить имя блока из определения блока. Следующий код позволяет выбрать вставку блока и получить его имя:

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Показ локализованных имён свойств с использованием Не-COM системы свойств

Если вы уже начали использовать Не-COM систему свойств в AutoCAD, пожалуйста, посмотрите эту презентацию (DevTV) моего коллеги, Adam Nagy. В этой статье мы рассмотрим изменения, которые потребуются для показа локализованных имён с использованием Не-COM системы свойств.

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Площадь пересечения двух AcDbRegion

Следующий пример показывает использование метода AcDbRegion::booleanOper() для пересечения двух примитивов область (AcDbRegion)...

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Печать листов с использованием объекта Plot ActiveX в ObjectARX

Следующий код показывает как напечатать все листы в пакетном режиме с использованием ActiveX API в C++

Ключевые моменты для пакетной печати:

1) Установим число листов, которые будут напечатаны при помощи метода StartBatchMode() объекта IAcadPlot ...

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Перехват вывода в текстовый экран и командную строку AutoCAD

Вопрос:

Как получить текстовый вывод команд, таких как СПИСОК (_LIST), а также скрыть вывод некоторых команд в командную строку?

Ответ:

Вы можете временно подменить объект HostApplicationServices своим собственным...

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Пересечение Поверхности и Отрезка с использованием ARX

В другой статье, мой коллега Philippe рассказал о получении точки пересечения между плоскостью и отрезком. В этой статье мы увидим, как получить пересечение любой поверхности и отрезка.

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Пересечение между примитивами 3-ГРАНЬ и ОТРЕЗОК при помощи ARX

Вопрос:
Как можно вычислить точку пересечения (если она есть) между AcDbFace и AcDbLine

Ответ:
Существуют два основных пути которыми это можно осуществлено с помощью ARX и оба они далее показаны:

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Перезентация (DevTV): Не-COM система свойств

Мы создали презентацию (DevTV) по Не-COM системе свойств (кодовое имя Ubiquity), публичное API, которое получила последняя версия AutoCAD. В прошлом нужно было создавать COM классы для добавления свойств собственных объектов в Палитру свойств. Теперь вы можете делать это без использования COM – поэтому мы её и назвали ‘Не-COM система свойств'.

Опубликовано 29.05.2013     Читать далее >>>
29/05/2013

Перебор всех IAcadBlock в IAcadBlocks используя ActiveX в C++

Вопрос:
В C++ я не вижу возможности перебрать IAcadBlocks, чтобы получить доступ к каждому IAcadBlock. Есть пример кода, который это делает?

Ответ:
Следующие два подхода перебирают IAcadBlocks для доступа к каждому IAcadBlock. Первый предполагает, что вы настроили ваш проект с использованием ARX/MFC и импортирована TLB-библиотеки AutoCAD COM.

Опубликовано 29.05.2013     Читать далее >>>
24/05/2013

Отображение пользовательского примитива при перетаскивании

Если пользовательский примитив унаследован от AcDbEntity и использует методы polyline() и polygon() класса AcGiWorldGeometry внутри метода worldDraw(), то в ряде случаев функции могут возвращать состояние ошибки если используются при перетаскивании или редактировании при помощи ручек (grips).

Опубликовано 24.05.2013     Читать далее >>>
24/05/2013

Об автосохранении и уведомлениях/событиях

Когда AutoCAD выполняет автосохранение, он сохраняет чертежи в каталог Temp операционной системы с именами "DrawingName_Numbers.ac$", как указано в диалоге Параметры, и посылает сообщение kSaveMsg всем приложениям:

Опубликовано 24.05.2013     Читать далее >>>